import greenfoot.*;  
import java.awt.Color;

/**
 * @author (Sugeng Rianto and Ubaidillah) 
 * @version (1.0)
 */

public class Page extends Actor
{
    private Latar latar=null;
    private int posx=0,posy=0;
    public GreenfootImage imagea=new GreenfootImage(300,400);
    public GreenfootImage imageb=new GreenfootImage(300,400);
    private boolean drag=false,awal=true;
    private int rx=0,ry=0,ujung=0,hmax=70;
    
    public void makeFront()
    {
        int xo=posx,yo=posy;
        int x=getX(),y=getY();
        latar.removeObject(this);
        latar.addObject(this,x,y);
        posx=xo;posy=yo;
    }
    
    public void update(int x,int y)
    {
        double scale=1.0*(x-posx)/imagea.getWidth();
        GreenfootImage image=new GreenfootImage(imagea);
        int a=1;
        if(scale<0){
            image=new GreenfootImage(imageb);
            a=-1;
        }
        if(scale>1) scale=1;
        if(scale<-1)scale=-1;
        int scalex=(int)(Math.abs(scale)*image.getWidth());
        int scaley=(int)((1-Math.abs(scale))*hmax);
        if(scalex==0)scalex=1;
        image.scale(scalex,image.getHeight());
        GreenfootImage imageo=new GreenfootImage(image.getWidth(),image.getHeight()+scaley);
        for(int i=0;i<image.getWidth();i++){
            for(int j=0;j<image.getHeight();j++){
                Color warna=image.getColorAt(i,j);
                if(a>0)imageo.setColorAt(i,j+(int)(1.0*(image.getWidth()-i)*scaley/image.getWidth()),warna);
                else imageo.setColorAt(i,j+(int)(1.0*(1+i)*scaley/image.getWidth()),warna);
            }
        }
        setImage(imageo);
        ujung=posx+(int)(a*image.getWidth());
        setLocation(posx+(int)(a*0.5*image.getWidth()),posy-(int)(0.5*scaley));
    }
    
    public void setGambar()
    {        
        imagea.setColor(Color.RED);
        imagea.fillRect(0,0,300-1,400-1);
        imageb.setColor(Color.BLUE);
        imageb.fillRect(0,0,300-1,400-1);
        imagea.setColor(Color.BLACK);
        imagea.drawRect(0,0,300-1,400-1);
        imagea.drawRect(10,10,300-21,400-21);
        imageb.setColor(Color.BLACK);
        imageb.drawRect(0,0,300-1,400-1);
        imageb.drawRect(10,10,300-21,400-21);
    }
    
    public void addedToWorld(World Latar)
    {
        latar=(Latar)getWorld(); 
        posx=(int)(0.5*latar.getWidth());
        posy=(int)(0.5*latar.getHeight());
        setGambar();
        ujung=posx+imagea.getWidth();
        setImage(imagea);
        setLocation(posx+(int)(0.5*imagea.getWidth()),posy);
        if(!awal)update(getX(),getY()); 
        if(awal)awal=false;
    }
    
    public void act()
    {           
        if(Greenfoot.mouseDragged(this)){
            MouseInfo mouse=Greenfoot.getMouseInfo();
            if(!drag){
                rx=ujung-mouse.getX();
                makeFront();
                drag=true;
            }
            
            if(drag){
                update(rx+mouse.getX(),getY()); 
            }
        }
        
        if(!drag){
            int b=0;
            if(ujung<posx){
                ujung-=30; 
            }
        
            if(ujung>posx){
                ujung+=30; 
            }
            update(ujung,getY());
        }
        
        if(Greenfoot.mouseDragEnded(this)) {
            drag=false;
        }
    }
}
